/**
 * :Author: Valerio Maggio
 * :Organization: University of Naples Federico II
 * :Contact: valerio.maggio@unina.it
 */

package lectures.softeng.calculator;

public class Calculator {

    private double memory;

    public static final double MAX_DIGITS_LEN = 5;

    public Calculator(){
        this.memory = 0.0;
    }

    public double add(double augend, double addend) {
        checkNegativeInput(augend, addend);
        return augend + addend;
    }

    public double subtract(double minuend, double subtrahend){
        checkNegativeInput(minuend, subtrahend);
        return minuend - subtrahend;
    }

    private void checkNegativeInput(double firstValue, double secondValue) {
        if ((firstValue < 0) || (secondValue < 0))
            throw new RuntimeException();
    }

    public double multiply(double multiplicand, double multiplier){
        checkNegativeInput(multiplicand, multiplier);
        return multiplicand * multiplier;
    }

    public double divide(double dividend, double divisor){
        checkNegativeInput(dividend, divisor);
        return dividend / divisor;
    }

    public void addToMemory(double number){
        this.memory = number;
    }

    public double recallNumber(){
        return this.memory;
    }
}
