/**
 * :Author: Valerio Maggio
 * :Organization: University of Naples Federico II
 * :Contact: valerio.maggio@unina.it
 */

package lectures.softeng.calculator;

import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.fail;

public class TestCalculator {

    private Calculator calculator;

    @Before
    public void setUp(){
        this.calculator = new Calculator();
    }

    @Test
    public void testThatSummationOnTwoNumbersReturnsTheCorrectValue(){
//        Calculator calculator = new Calculator();
        double result = calculator.add(0, 60);
        assertEquals(60, result, 0);
    }


    @Test
    public void testThatAnExceptionIsRaisedOnNegativeInputValues(){

        try{
            calculator.add(-1, -3);
            fail("Addition did not throw any Exception");
        } catch (RuntimeException re) {}

        try{
            calculator.subtract(-2, -4);
            fail("Substraction did not throw any Exception");
        } catch (RuntimeException re) {}

        try{
            calculator.multiply(-2, -4);
            fail("Multiplication did not throw any Exception");
        } catch (RuntimeException re) {}

        try{
            calculator.divide(-2, -4);
            fail("Division did not throw any Exception");
        } catch (RuntimeException re) {}

    }

    @Test
    public void testThatMemoryAttributeIsCorrectlyHandled(){
        assertEquals(0, calculator.recallNumber(), 0);
        calculator.addToMemory(12);
        assertEquals(12, calculator.recallNumber(), 0);


    }


}
