package lectures.softeng.stack;

import java.util.ArrayList;

/**
 * :Author: Valerio Maggio
 * :Organization: University of Naples Federico II
 * :Contact: valerio.maggio@unina.it
 */

public class Stack {

    private ArrayList<Process> _list;

    public Stack(){
        this._list = new ArrayList<Process>();
    }

    public Stack(int capacity){
        this._list = new ArrayList<Process>(capacity);
    }

    public Process pop(){
        return this._list.get(0);
    }

    public void push(Process p){
        this._list.add(0, p);
    }

}

class Process{
    private String name;
    private int pid;
    private int priority = -1;


    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getPid() {
        return pid;
    }

    public void setPid(int pid) {
        this.pid = pid;
    }

    public int getPriority() {
        return priority;
    }

    public void setPriority(int priority) {
        this.priority = priority;
    }
}
